--[[Concept - extremely simple bars - one for Morale and one for Power. No numeric display, nothing. Just nice simple bars.]]--

import "Turbine.UI"
import "Turbine.Gameplay"
import "JackdawPlugins.VBar.Class"
import "Deusdictum.UI.Dragbar"

	Player = Turbine.Gameplay.LocalPlayer.GetInstance();

	--Callback handler - Due to Pengoros... Many thanks!
function AddCallback(object, event, callback)
    if (object[event] == nil) then
        object[event] = callback;
    else
        if (type(object[event]) == "table") then
            table.insert(object[event], callback);
        else
            object[event] = {object[event], callback};
        end
    end
    return callback;
end

local Load=Turbine.PluginData.Load( Turbine.DataScope.Character, "VBar" )
Morale=Bar()	Power=Bar()
if Load==nil then

	Morale:SetSize(20,100)
	Morale:SetPosition(100,100)
	Morale:Orient("d")

	Power:SetSize(20,100)
	Power:SetPosition(120,100)
	Power:Orient("d")

else
	
	Morale:SetSize(Load[1].Data.sx,Load[1].Data.sy)
	Morale:SetPosition(Load[1].Data.x,Load[1].Data.y)
	Morale:Orient(Load[1].Data.Orient)

	Power:SetSize(Load[2].Data.sx,Load[2].Data.sy)
	Power:SetPosition(Load[2].Data.x,Load[2].Data.y)
	Power:Orient(Load[2].Data.Orient)

end
	Morale:SetName("Morale")
	Morale:SetBorderColor(Turbine.UI.Color(1,0.5,0.5,0.5))
	Morale:SetBorderWidth(1)
	Morale:SetBackgroundColor(Turbine.UI.Color(0.5,0,0,0))
	Morale:SetBarColor(Turbine.UI.Color(1,0,1,0))
	Morale:SetFill(0.8)
	
	Power:SetName("Power")
	Power:SetBorderColor(Turbine.UI.Color(1,0.5,0.5,0.5))
	Power:SetBorderWidth(1)
	Power:SetBackgroundColor(Turbine.UI.Color(0.5,0,0,0))
	Power:SetBarColor(Turbine.UI.Color(1,0,0,1))
	Power:SetFill(0.8)
	

Plugins["VBar"].Unload = function( sender, args )
	Morale:GetPosition()
	Power:GetPosition()
	Turbine.PluginData.Save( Turbine.DataScope.Character, "VBar", {Morale,Power} )
end

Morale:SetFill(Player:GetMorale()/Player:GetMaxMorale())
Power:SetFill(Player:GetPower()/Player:GetMaxPower()) 
	
--Callbacks when Morale or Power changes.
AddCallback(Player,"MoraleChanged", function(sender, args) 	Morale:SetFill(Player:GetMorale()/Player:GetMaxMorale()) 	end)
AddCallback(Player,"PowerChanged", function(sender, args) 	Power:SetFill(Player:GetPower()/Player:GetMaxPower()) 		end)

--Add a callbacks if the players maximum morale/power changes.
AddCallback(Player, "BaseMaxMoraleChanged", function(sender, args) Morale:SetFill(Player:GetMorale()/Player:GetMaxMorale()) end)
AddCallback(Player, "BaseMaxPowerChanged", function(sender, args)	Power:SetFill(Player:GetPower()/Player:GetMaxPower()) end)
	
	
--Watch for the UI being unlocked, this will then make all the controls fill to 80% and Mouse-visible.

Morale.Window.DragEnable= function()
			Morale:SetFill(0.8)
			Power:SetFill(0.8) 
			Morale:SetOpacity(1)
			Power:SetOpacity(1)
			Morale:SetMouseVisible(true)
			Power:SetMouseVisible(true)
		end
Morale.Window.DragDisable= function ()
			Morale:SetFill(Player:GetMorale()/Player:GetMaxMorale())
			Power:SetFill(Player:GetPower()/Player:GetMaxPower()) 
			Morale:SetMouseVisible(false)
			Power:SetMouseVisible(false)
		end

--Testing command
shellCommand = Turbine.ShellCommand()
function shellCommand:Execute(command, i)
	Morale:SetFill(tonumber(i)or 1)
	Power:SetFill(tonumber(i)or 1)
end
Turbine.Shell.AddCommand('VB', shellCommand)